TOOLS: JCHRONOSS Version 2.0 {#toolspage}
===============================================================================

__Last Updated:__ *February 6, 2017*

Beyond the core functionality provided by JCHRONOSS, the project distributes
three mini-tools aiming to help the user with JCHRONOSS data handling. 


Scheduling Trace Visualizer
-------------------------------------------------------------------------------

JsLoc (for Job Scheduling LOCality) is our scheduling policy visualizer. You can
find the implementation in `tools/jsloc`. This python-based software aims to
draw the overall job distribution over run time. This way, it becomes possible
to know if the given configuration is suited for the given architecture. Users
are roughly encouraged to run this tool on first runs to ensure JCHRONOSS takes
the best of resources.

__WARNING:__ To use this tool, Jsloc needs trace files generated by JCHRONOSS
core. To have it, you have to run `cmake -DENABLE_TRACE=ON` to ensure trace
generations.

It is easy to use. You have to 
1. Know where your `build/` folder is (by default in`$PWD`). JCHRONOSS master
   stores in it, one file per slave, named testFile-\*.trace.  These files
   contain information about the slave and jobs scheduled by it (timestamps,
   resource values, etc.).
2. Know the number of resources handled by the run (`--nb-resources` option).

Jsloc can be launched directly through a Shell script with 2 arguments:
* `--in=/build_path/`
* `--res=<number_of_resources>`

	$user /tools/jsLoc/> ./jsLoc_gen_all.sh --in=${BUILD}/build/traces/ --res=32

Jsloc generates 3 types of graphs:
* __Intra-slave Scheduling:__ This drawing shows how jobs have been scheduled by
  the referent file. It is possible to see where "blank" space is, meaning
  allocated but not used time.
* __Inter-slave Scheduling:__ This drawing shows how multiple workers have been coordinated over time, the number of blocks depends on your policy.
* __Overall scheduling:__ This graph, which can take a while to be generated,
  builds a complete representation of your run over time, letting you free to
  adjust your run scheme if scheduling does not plan as expected.

The capture below shows an example of complete scheduling graph over 32-node
validation:

![Screenshot of Jsloc standard output](../../../tools/resources/jsloc.png)

Stand-alone Result Reviewer
-------------------------------------------------------------------------------

After the validation, you wish to review data in a user-friendly interface,
analyzes your results by package, by exit status, etc. A lot of dedicated
platforms do that very well. The problem is you may not have such kind of
environment directly after your validation. Sometimes, you even need to move
this data to another environment before attempting to have your result. To
avoid this time waste, we added to JCHRONOSS a lightweight static web-site,
written with Bootstrap & JQuery (no server side) to create in-place result
access. You only need a browser supporting Javascript.

You can find source code in `tools/webview`. To generate static contents from
JUnit output, simply run:

	$user> ./webview_gen_all.sh --in=/path/to/files

All output-\*.xml will be found recursively and transformed through XSLT to
produce a lightweight and responsive interface. You should have `xsltproc` in
your path in order to process the webview. This webview is composed of three
views:
* __Home__: Main page, you can see a global summary for the whole validation. One
  entry is mapped to one file;
* __Errors__: A list of failures;
* __Compare__: (WIP) A diff interface to compare 2 runs;
* __Real-time__: By connecting to a running JCHRONOSS program, you can browse
  results without waiting for the run to complete. This is done through a
  WebSockets connection between JCHRONOSS and the interface. You have to be sure
  your browser supports this technology.

Here a screenshot of this interface:
![Stand-alone Reviewing Platform](../../../tools/resources/webview.png)


Input Data Building Helper
-------------------------------------------------------------------------------

With the objective of simplification, JCHRONOSS embeds a little module designed 
to help users to generate multiple data set for JCHRONOSS. In particular,
this module can help you to build:
* The exact command line, ready-to-paste, depending on your chosen configuration
* The configuration file, to reduce number of command-line arguments
* Job files, well formatted.

![Input Helper interface](../../../tools/resources/inputh.png)
